"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Initialize = exports.initialize = exports.getMetadataStorage = exports.getStore = void 0;
var MetadataStorage_1 = require("./MetadataStorage");
function getStore() {
    return global;
}
exports.getStore = getStore;
function initializeMetadataStorage() {
    var store = getStore();
    if (!store.metadataStorage) {
        store.metadataStorage = new MetadataStorage_1.MetadataStorage();
    }
}
/**
 * Return exisiting metadataStorage, otherwise create if not present
 */
var getMetadataStorage = function () {
    var store = getStore();
    initializeMetadataStorage();
    return store.metadataStorage;
};
exports.getMetadataStorage = getMetadataStorage;
var initialize = function (firestore, config) {
    if (config === void 0) { config = { validateModels: false, validatorOptions: {} }; }
    initializeMetadataStorage();
    var metadataStorage = getStore().metadataStorage;
    metadataStorage.firestoreRef = firestore;
    metadataStorage.config = config;
};
exports.initialize = initialize;
/**
 * @deprecated Use initialize. This will be removed in a future version.
 */
exports.Initialize = exports.initialize;
//# sourceMappingURL=MetadataUtils.js.map